package org.itqop.chatit.commands;

import com.mojang.brigadier.CommandDispatcher;
import net.minecraft.commands.Commands;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.network.chat.Component;
import net.minecraftforge.event.RegisterCommandsEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import org.itqop.chatit.utils.PlayerConfigManager;

@Mod.EventBusSubscriber
public class ChatITCommand {

    @SubscribeEvent
    public static void onRegisterCommands(RegisterCommandsEvent event) {
        CommandDispatcher<CommandSourceStack> dispatcher = event.getDispatcher();

        dispatcher.register(Commands.literal("chatit")
                .then(Commands.literal("adult")
                        .requires(source -> source.hasPermission(2))
                        .executes(context -> {
                            ServerPlayer player = context.getSource().getPlayerOrException();
                            PlayerConfigManager.toggleAdultContent(player);
                            boolean current = PlayerConfigManager.hasAdultContentEnabled(player);
                            String status = current ? "включен" : "выключен";
                            player.sendSystemMessage(Component.literal("Параметр adult теперь " + status + "."));
                            return 1;
                        })
                )
        );
    }
}
